# I2C Driver

## Overview
The Inter-Integrated Circuit (I2C) bus is a multi-host serial data communication bus. Devices communicate in a host/
client environment where the host devices initiate the communication. A client device is controlled through
addressing.

## Generated Files
This driver generates the following files:
I2C Host Mode:
* ./mcc_generated_files/i2c_host/src/twi0.c => A driver file containing Register Initialization and API function implementations
* ./mcc_generated_files/i2c_host/twi0.h => A driver file containing the API function prototypes
* ./mcc_generated_files/i2c_host/twi0_host_interface.h => A driver file containing the Common API function prototypes structure
* ./mcc_generated_files/i2c_host/twi0_host_type.h => A driver file containing the type definition for i2c host 
* ./mcc_generated_files/i2c_host/twi0_host_event_types.h => A driver file containing the structure definition for i2c host

I2C Client Mode:
* ./mcc_generated_files/i2c_client/src/twi0.c => A driver file containing Register Initialization and API function implementations
* ./mcc_generated_files/i2c_client/twi0.h => A driver file containing the API function prototypes
* ./mcc_generated_files/i2c_client/twi0_client_interface.h => A driver file containing the Common API function prototypes structure
* ./mcc_generated_files/i2c_client/twi0_client_type.h => A driver file containing the type definition for i2c client 

# Changelog
All notable changes to this project will be documented in this file.

## [7.1.1] - 2022-02-23

### Bug Fixes
- **CC8SCRIP-6922** :- AVR GCC Compiler Support


## [7.1.0] - 2021-12-17

### New Features
- **CC8SCRIP-6612** :- Added I2C Host and I2C Client drivers with respective Basic UIs to facilitate migration across PICs, AVRs and dsPICs


## [7.0.0] - 2021-10-05

### Improvements
- **CC8SCRIP-4943** :- Redesigned TWI with non-blocking routines and portable interfaces
