/**
 * ${moduleNameUpperCase} Generated Driver API Header File
 *
 * @file ${moduleNameLowerCase}.h
 *
 * @defgroup ${moduleNameLowerCase}_client ${moduleNameUpperCase}_client
 *
 * @brief This header file provides APIs for the ${moduleNameUpperCase} driver.
 *
 * @version ${moduleNameUpperCase} Driver Version 1.1.0
*/
${disclaimer}

#ifndef ${moduleNameUpperCase}_CLIENT_INTERRUPT_H
#define ${moduleNameUpperCase}_CLIENT_INTERRUPT_H

#include <stdbool.h>
#include <stdint.h>
#include "${moduleGroupNameLowerCase}_client_types.h"
#include "${moduleGroupNameLowerCase}_client_interface.h"

/**
 Section: Data Type Definitions
*/

#define ${componentNameLowerCase}_client_interface ${componentName}
<#if componentNameLowerCase!=moduleNameLowerCase>

#define ${componentName}_Initialize ${moduleNameUpperCase}_Initialize
#define ${componentName}_Deinitialize ${moduleNameUpperCase}_Deinitialize
#define ${componentName}_WriteByte ${moduleNameUpperCase}_WriteByte
#define ${componentName}_ReadByte ${moduleNameUpperCase}_ReadByte
#define ${componentName}_ReadAddr ${moduleNameUpperCase}_ReadAddr
#define ${componentName}_ErrorGet ${moduleNameUpperCase}_ErrorGet
#define ${componentName}_TransferDirGet ${moduleNameUpperCase}_TransferDirGet
#define ${componentName}_LastByteAckStatusGet ${moduleNameUpperCase}_LastByteAckStatusGet
#define ${componentName}_CallbackRegister ${moduleNameUpperCase}_CallbackRegister
#define ${componentName}_Tasks ${moduleNameUpperCase}_Tasks
</#if>

extern const struct ${moduleGroupNameUpperCase}_CLIENT_INTERFACE ${componentName};

/**
 * @ingroup ${moduleGroupNameUpperCase}_client
 * @brief This API initializes the ${moduleNameUpperCase} module.
 * @param void
 * @return void
 */ 
void ${moduleNameUpperCase}_Initialize(void);

/**
 * @ingroup ${moduleGroupNameUpperCase}_client
 * @brief This API Deinitializes the ${moduleNameUpperCase} module. This routine disables the ${moduleNameUpperCase} module.
 * @param void
 * @return void
 */
void ${moduleNameUpperCase}_Deinitialize(void);

/**
 * @ingroup ${moduleGroupNameUpperCase}_client
 * @brief This function writes data to a host on the bus.
 * @param [in] wrByte - ${moduleNameUpperCase} client write byte
 * @return void
 */
void ${moduleNameUpperCase}_WriteByte(uint8_t wrByte);

/**
 * @ingroup ${moduleGroupNameUpperCase}_client
 * @brief This function read data from a host on the bus.
 * @param void
 * @return data byte -${moduleNameUpperCase} client read byte
 */
uint8_t ${moduleNameUpperCase}_ReadByte(void);

/**
 * @ingroup ${moduleGroupNameUpperCase}_client
 * @brief This function read requested address from a host on the bus.
 * @param void
 * @return address byte -${moduleNameUpperCase} client read byte
 */
uint16_t ${moduleNameUpperCase}_ReadAddr(void);

/**
 * @ingroup ${moduleGroupNameUpperCase}_client
 * @brief This function the error occurred during ${moduleGroupNameUpperCase} Transmit and Receive.
 * @param void
 * @retval  ${moduleGroupNameUpperCase}_CLIENT_ERROR_BUS_COLLISION    - ${moduleGroupNameUpperCase} Bus Collision Error
 * @retval  ${moduleGroupNameUpperCase}_CLIENT_ERROR_WRITE_COLLISION  - ${moduleGroupNameUpperCase} Write Collision Error
 * @retval  ${moduleGroupNameUpperCase}_CLIENT_ERROR_RECEIVE_OVERFLOW - ${moduleGroupNameUpperCase} Receive overflow
 * @retval  ${moduleGroupNameUpperCase}_CLIENT_ERROR_NONE             - No Error
 */
${moduleGroupNameLowerCase}_client_error_t ${moduleNameUpperCase}_ErrorGet(void);

/**
 * @ingroup ${moduleGroupNameUpperCase}_client
 * @brief This function get the ${moduleGroupNameUpperCase} Transfer direction.
 * @param void
 * @retval  ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_DIR_WRITE  - ${moduleGroupNameUpperCase} Host is writing to client
 * @retval  ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_DIR_READ   - ${moduleGroupNameUpperCase} Host is reading from client
 */
${moduleGroupNameLowerCase}_client_transfer_dir_t ${moduleNameUpperCase}_TransferDirGet(void);

/**
 * @ingroup ${moduleGroupNameUpperCase}_client
 * @brief This function get the ${moduleGroupNameUpperCase} Host ACK status.
 * @param void
 * @retval  ${moduleGroupNameUpperCase}_CLIENT_ACK_STATUS_RECEIVED_ACK   - ${moduleGroupNameUpperCase} Host sent ACK to client
 * @retval  ${moduleGroupNameUpperCase}_CLIENT_ACK_STATUS_RECEIVED_NACK  - ${moduleGroupNameUpperCase} Host sent NACK to client
 */
${moduleGroupNameLowerCase}_client_ack_status_t ${moduleNameUpperCase}_LastByteAckStatusGet(void);

/**
 * @ingroup ${moduleGroupNameUpperCase}_client
 * @brief This function sets the pointer to be called "back" when
 *        the given ${moduleGroupNameUpperCase} transfer events, Bus collision and Write collision occur.
 * @param handler - A pointer to a function.
 * @return void
 */
void ${moduleNameUpperCase}_CallbackRegister(bool (*callback)(${moduleGroupNameLowerCase}_client_transfer_event_t clientEvent));

/**
 * @ingroup ${moduleGroupNameUpperCase}_client
 * @brief This function is common Polling function for all ${moduleNameUpperCase} client.
 * @param void.
 * @return void
 */
void ${moduleNameUpperCase}_Tasks(void);

#endif /* ${moduleNameUpperCase}_CLIENT_INTERRUPT_H */
