/**
 * ${moduleNameUpperCase} Generated Driver API Header File
 *
 * @file {moduleGroupNameLowerCase}_client_types.h
 *
 * @defgroup ${moduleNameLowerCase}_client_types ${moduleNameUpperCase}_CLIENT_TYPES
 *
 * @brief This header file provides APIs for the ${moduleNameUpperCase} driver.
 *
 * @version ${moduleNameUpperCase} Driver Version 2.0.1
*/

${disclaimer}

#ifndef ${moduleGroupNameUpperCase}_CLIENT_TYPES_H
#define	${moduleGroupNameUpperCase}_CLIENT_TYPES_H

/**
 * @ingroup ${moduleGroupNameLowerCase}_client_interface
 * @enum ${moduleGroupNameLowerCase}_client_transfer_dir_t
 * @brief ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_DIR Enumeration
 */
typedef enum
{
    ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_DIR_WRITE = 0,       /**< ${moduleGroupNameUpperCase} Host is writing to client */
    ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_DIR_READ  = 1,       /**< ${moduleGroupNameUpperCase} Host is reading from client */
} ${moduleGroupNameLowerCase}_client_transfer_dir_t;

/**
 * @ingroup ${moduleGroupNameLowerCase}_client_interface
 * @enum ${moduleGroupNameLowerCase}_client_ack_status_t
 * @brief ${moduleGroupNameUpperCase} Ack/Nack status enumeration
 */
typedef enum
{
    ${moduleGroupNameUpperCase}_CLIENT_ACK_STATUS_RECEIVED_ACK = 0,  /**< ${moduleGroupNameUpperCase} Host is send ACK to client */
    ${moduleGroupNameUpperCase}_CLIENT_ACK_STATUS_RECEIVED_NACK = 1, /**< ${moduleGroupNameUpperCase} Host is send NACK to client */
} ${moduleGroupNameLowerCase}_client_ack_status_t;

/**
 * @ingroup ${moduleGroupNameLowerCase}_client_interface
 * @enum ${moduleGroupNameLowerCase}_client_transfer_event_t
 * @brief ${moduleGroupNameUpperCase} notification event type
 */
typedef enum
{
    ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_NONE = 0,          /**< ${moduleGroupNameUpperCase} Bus Idle state */
    ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_ADDR_MATCH,        /**< Address match event */
    ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_RX_READY ,         /**< Data sent by ${moduleGroupNameUpperCase} Host is available */
    ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_TX_READY,          /**< ${moduleGroupNameUpperCase} client can respond to data read request from ${moduleGroupNameUpperCase} Host */
    ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_STOP_BIT_RECEIVED, /**< ${moduleGroupNameUpperCase} stop bit received */
    ${moduleGroupNameUpperCase}_CLIENT_TRANSFER_EVENT_ERROR,             /**< ${moduleGroupNameUpperCase} Bus error occurred */
} ${moduleGroupNameLowerCase}_client_transfer_event_t;

/**
 * @ingroup ${moduleGroupNameLowerCase}_client_interface
 * @enum ${moduleGroupNameLowerCase}_client_error_t
 * @brief ${moduleGroupNameUpperCase} client error type indicator
 */
typedef enum
{
    ${moduleGroupNameUpperCase}_CLIENT_ERROR_NONE = 0,       /**< ${moduleGroupNameUpperCase} error none */
    ${moduleGroupNameUpperCase}_CLIENT_ERROR_BUS_ERROR,      /**< ${moduleGroupNameUpperCase} Bus Error occurred */
    ${moduleGroupNameUpperCase}_CLIENT_ERROR_COLLISION,      /**< ${moduleGroupNameUpperCase} Collision occurred */
} ${moduleGroupNameLowerCase}_client_error_t;

#endif // end of ${moduleGroupNameUpperCase}_CLIENT_TYPES_H