/**
 * ${moduleNameUpperCase} Generated Driver API Header File
 *
 * @file {moduleGroupNameLowerCase}_host_event_types.h
 *
 * @defgroup ${moduleNameLowerCase}_host_event ${moduleNameUpperCase}_HOST_EVENT
 *
 * @brief This header file provides APIs for the ${moduleNameUpperCase} driver.
 *
 * @version ${moduleNameUpperCase} Driver Version 2.0.1
*/

${disclaimer}

#ifndef ${moduleGroupNameUpperCase}_HOST_EVENT_TYPES_H
#define	${moduleGroupNameUpperCase}_HOST_EVENT_TYPES_H

#include "${moduleGroupNameLowerCase}_host_types.h"

/**
 * @ingroup ${moduleNameLowerCase}_host_event
 * @typedef enum ${moduleGroupNameLowerCase}_event_states_t
 * @brief Enumeration for ${moduleGroupNameUpperCase} states.
 */
typedef enum
{
    ${moduleGroupNameUpperCase}_STATE_IDLE = 0,
    ${moduleGroupNameUpperCase}_STATE_SEND_RD_ADDR,
    ${moduleGroupNameUpperCase}_STATE_SEND_WR_ADDR,
    ${moduleGroupNameUpperCase}_STATE_TX,
    ${moduleGroupNameUpperCase}_STATE_RX,
    ${moduleGroupNameUpperCase}_STATE_NACK,
    ${moduleGroupNameUpperCase}_STATE_ERROR,
    ${moduleGroupNameUpperCase}_STATE_STOP,
    ${moduleGroupNameUpperCase}_STATE_RESET
} ${moduleGroupNameLowerCase}_event_states_t;

/**
 * @ingroup ${moduleNameLowerCase}_host_event
 * @typedef struct ${moduleGroupNameLowerCase}_event_status_t
 * @brief ${moduleGroupNameUpperCase} Event Status Structure.
 */
typedef struct
{
    bool busy;
    uint16_t address;
    uint8_t *writePtr;
    size_t writeLength;
    uint8_t *readPtr;
    size_t readLength;
    bool switchToRead;
    ${moduleGroupNameLowerCase}_host_error_t errorState; 
    ${moduleGroupNameLowerCase}_event_states_t state;
} ${moduleGroupNameLowerCase}_event_status_t;

#endif // end of ${moduleGroupNameUpperCase}_HOST_EVENT_TYPES_H