/**
  * ${moduleNameUpperCase} Generated Driver File
  *
  * @file ${moduleNameLowerCase}.c
  *
  * @ingroup ${moduleNameLowerCase}_host
  *
  * @brief This file contains the driver code for ${moduleNameUpperCase} module.
  *
  * @version ${moduleNameUpperCase} Driver Version 2.1.0
*/

${disclaimer}

#include "../${header.name}"
#include <stdbool.h>
#include <stdlib.h>
#include "../../system/utils/compiler.h"

static void ${moduleNameUpperCase}_Close(void);
static void ${moduleNameUpperCase}_ReadStart(void);
static void ${moduleNameUpperCase}_WriteStart(void);
static void ${moduleNameUpperCase}_EventHandler(void);
static void ${moduleNameUpperCase}_ErrorEventHandler(void);
static void ${moduleNameUpperCase}_DefaultCallback(void);

/* I2C Internal API's */
static uint8_t ${moduleNameUpperCase}_GetRxData(void);
static void ${moduleNameUpperCase}_SendTxData(uint8_t data);
static void ${moduleNameUpperCase}_SendTxAddr(uint8_t data);
static inline void ${moduleNameUpperCase}_ClearInterruptFlag(void);
static inline void ${moduleNameUpperCase}_ResetBus(void);
static inline void ${moduleNameUpperCase}_EnableRestart(void);
static inline void ${moduleNameUpperCase}_DisableRestart(void);
static inline void ${moduleNameUpperCase}_SendStop(void);
static bool ${moduleNameUpperCase}_IsNack(void);
static bool ${moduleNameUpperCase}_IsBusError(void);
static bool ${moduleNameUpperCase}_IsData(void);
static bool ${moduleNameUpperCase}_IsAddr(void);
static inline void ${moduleNameUpperCase}_ClearErrorFlags(void);
static inline void ${moduleNameUpperCase}_EnableInterrupts(void);
static inline void ${moduleNameUpperCase}_DisableInterrupts(void);
static inline void ${moduleNameUpperCase}_ClearInterrupts(void);
static inline void ${moduleNameUpperCase}_HostSendAck(void);
static inline void ${moduleNameUpperCase}_HostSendNack(void);
static bool ${moduleNameUpperCase}_IsArbitrationlostOverride(void);

/* Host */
/* ${moduleNameUpperCase} interfaces */
static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_IDLE(void);
static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_SEND_RD_ADDR(void);
static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_SEND_WR_ADDR(void);
static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_TX(void);
static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_RX(void);
static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_NACK(void);
static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_ERROR(void);
static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_STOP(void);
static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_RESET(void);

/**
  Section: Driver Interface
*/
const ${moduleGroupNameLowerCase}_host_interface_t ${componentName} = {
  .Initialize = ${moduleNameUpperCase}_Initialize,
  .Deinitialize = ${moduleNameUpperCase}_Deinitialize,
  .Write = ${moduleNameUpperCase}_Write,
  .Read = ${moduleNameUpperCase}_Read,
  .WriteRead = ${moduleNameUpperCase}_WriteRead,
  .TransferSetup = NULL,
  .ErrorGet = ${moduleNameUpperCase}_ErrorGet,
  .IsBusy = ${moduleNameUpperCase}_IsBusy,
  .CallbackRegister = ${moduleNameUpperCase}_CallbackRegister,
  .Tasks = NULL
};

/**
 Section: Private Variable Definitions
 */
static void (*${moduleNameUpperCase}_Callback)(void) = NULL;
volatile ${moduleGroupNameLowerCase}_event_status_t ${moduleNameLowerCase}_Status = {0};

typedef ${moduleGroupNameLowerCase}_event_states_t (*${moduleNameLowerCase}eventHandler)(void);
const ${moduleNameLowerCase}eventHandler ${moduleNameLowerCase}_eventTable[] = {
    ${moduleGroupNameUpperCase}_EVENT_IDLE,
    ${moduleGroupNameUpperCase}_EVENT_SEND_RD_ADDR,
    ${moduleGroupNameUpperCase}_EVENT_SEND_WR_ADDR,
    ${moduleGroupNameUpperCase}_EVENT_TX,
    ${moduleGroupNameUpperCase}_EVENT_RX,
    ${moduleGroupNameUpperCase}_EVENT_NACK,
    ${moduleGroupNameUpperCase}_EVENT_ERROR,
    ${moduleGroupNameUpperCase}_EVENT_STOP,
    ${moduleGroupNameUpperCase}_EVENT_RESET
};

void ${moduleNameUpperCase}_Initialize(void)
{
    <#if CTRLA??>
    //${CTRLA.comment}
    ${moduleNameUpperCase}.${CTRLA.name} = ${CTRLA.valueAsHex};
    
    </#if>
    <#if DBGCTRL??>
    //Debug Run
    ${moduleNameUpperCase}.${DBGCTRL.name} = ${DBGCTRL.valueAsHex};
    
    </#if>
    <#if MBAUD??>
    //Host Baud Rate Control
    ${moduleNameUpperCase}.${MBAUD.name} = (uint8_t)${moduleNameUpperCase}_BAUD(${SCL_Frequency}, ${Trise});
    
    </#if>
    <#if MCTRLA??>
    //${MCTRLA.comment}
    ${moduleNameUpperCase}.${MCTRLA.name} = ${MCTRLA.valueAsHex};
    
    </#if>
    <#if MSTATUS??>
    //${MSTATUS.comment}
    ${moduleNameUpperCase}.${MSTATUS.name} = ${MSTATUS.valueAsHex};
    
    </#if>
    <#if MADDR??>
    //Host Address
    ${moduleNameUpperCase}.${MADDR.name} = ${MADDR.valueAsHex};
    
    </#if>
    <#if MCTRLB??>
    //${MCTRLB.comment}
    ${moduleNameUpperCase}.${MCTRLB.name} = ${MCTRLB.valueAsHex};
    
    </#if>
    <#if MDATA??>
    //Host Data
    ${moduleNameUpperCase}.${MDATA.name} = ${MDATA.valueAsHex};
    
    </#if>

    ${moduleNameUpperCase}.MCTRLB |= TWI_FLUSH_bm; 
    ${moduleNameUpperCase}.MSTATUS |= TWI_BUSSTATE_IDLE_gc;

    ${moduleNameUpperCase}_CallbackRegister(${moduleNameUpperCase}_DefaultCallback);
}

void ${moduleNameUpperCase}_Deinitialize(void)
{
    <#if CTRLA??>
    //${CTRLA.comment}
    ${moduleNameUpperCase}.${CTRLA.name} = 0x00;
    
    </#if>
    <#if DBGCTRL??>
    //Debug Run
    ${moduleNameUpperCase}.${DBGCTRL.name} = 0x00;
    
    </#if>
    <#if MBAUD??>
    //Host Baud Rate Control
    ${moduleNameUpperCase}.${MBAUD.name} = (uint8_t)${moduleNameUpperCase}_BAUD(${SCL_Frequency}, ${Trise});
    
    </#if>
    <#if MCTRLA??>
    //${MCTRLA.comment}
    ${moduleNameUpperCase}.${MCTRLA.name} = 0x00;
    
    </#if>
    <#if MSTATUS??>
    //${MSTATUS.comment}
    ${moduleNameUpperCase}.${MSTATUS.name} = 0x00;
    
    </#if>
    <#if MADDR??>
    //Host Address
    ${moduleNameUpperCase}.${MADDR.name} = 0x00;
    
    </#if>
    <#if MCTRLB??>
    //${MCTRLB.comment}
    ${moduleNameUpperCase}.${MCTRLB.name} = 0x00;
    
    </#if>
    <#if MDATA??>
    //Host Data
    ${moduleNameUpperCase}.${MDATA.name} = 0x00;

    ${moduleNameUpperCase}.MCTRLB |= TWI_FLUSH_bm; 
    ${moduleNameUpperCase}.MSTATUS |= TWI_BUSSTATE_IDLE_gc;

    ${moduleNameUpperCase}_CallbackRegister(${moduleNameUpperCase}_DefaultCallback);
    
    </#if>
}

bool ${moduleNameUpperCase}_Write(uint16_t address, uint8_t *data, size_t dataLength)
{
    bool retStatus = false;
    if (!${moduleNameUpperCase}_IsBusy())
    {
        ${moduleNameLowerCase}_Status.busy = true;
        ${moduleNameLowerCase}_Status.address = address;
        ${moduleNameLowerCase}_Status.switchToRead = false;
        ${moduleNameLowerCase}_Status.writePtr = data;
        ${moduleNameLowerCase}_Status.writeLength = dataLength;
        ${moduleNameLowerCase}_Status.readPtr = NULL;
        ${moduleNameLowerCase}_Status.readLength = 0;
        ${moduleNameLowerCase}_Status.errorState = ${moduleGroupNameUpperCase}_ERROR_NONE;
        ${moduleNameUpperCase}_WriteStart();
        retStatus = true;
    }
    return retStatus;
}

bool ${moduleNameUpperCase}_Read(uint16_t address, uint8_t *data, size_t dataLength)
{
    bool retStatus = false;
    if (!${moduleNameUpperCase}_IsBusy())
    {
        ${moduleNameLowerCase}_Status.busy = true;
        ${moduleNameLowerCase}_Status.address = address;
        ${moduleNameLowerCase}_Status.switchToRead = false;
        ${moduleNameLowerCase}_Status.readPtr = data;
        ${moduleNameLowerCase}_Status.readLength = dataLength;
        ${moduleNameLowerCase}_Status.writePtr = NULL;
        ${moduleNameLowerCase}_Status.writeLength = 0;
        ${moduleNameLowerCase}_Status.errorState = ${moduleGroupNameUpperCase}_ERROR_NONE;
        ${moduleNameUpperCase}_ReadStart();
        retStatus = true;
    }
    return retStatus;
}

bool ${moduleNameUpperCase}_WriteRead(uint16_t address, uint8_t *writeData, size_t writeLength, uint8_t *readData, size_t readLength)
{
    bool retStatus = false;
    if (!${moduleNameUpperCase}_IsBusy())
    {
        ${moduleNameLowerCase}_Status.busy = true;
        ${moduleNameLowerCase}_Status.address = address;
        ${moduleNameLowerCase}_Status.switchToRead = true;
        ${moduleNameLowerCase}_Status.writePtr = writeData;
        ${moduleNameLowerCase}_Status.writeLength = writeLength;
        ${moduleNameLowerCase}_Status.readPtr = readData;
        ${moduleNameLowerCase}_Status.readLength = readLength;
        ${moduleNameLowerCase}_Status.errorState = ${moduleGroupNameUpperCase}_ERROR_NONE;
        ${moduleNameUpperCase}_WriteStart();
        retStatus = true;
    }
    return retStatus;
}

${moduleGroupNameLowerCase}_host_error_t ${moduleNameUpperCase}_ErrorGet(void)
{
    ${moduleGroupNameLowerCase}_host_error_t retErrorState = ${moduleNameLowerCase}_Status.errorState;
    ${moduleNameLowerCase}_Status.errorState = ${moduleGroupNameUpperCase}_ERROR_NONE;
    return retErrorState;
}

bool ${moduleNameUpperCase}_IsBusy(void)
{
    return ${moduleNameLowerCase}_Status.busy || !(${moduleNameUpperCase}.MSTATUS & TWI_BUSSTATE_IDLE_gc);
}

void ${moduleNameUpperCase}_CallbackRegister(void (*callbackHandler)(void))
{
    if (callbackHandler != NULL)
    {
        ${moduleNameUpperCase}_Callback = callbackHandler;
    }
}

/**
 Section: Private Interfaces
 */

static void ${moduleNameUpperCase}_ReadStart(void)
{
    ${moduleNameLowerCase}_Status.state = ${moduleGroupNameUpperCase}_EVENT_SEND_RD_ADDR();
}

static void ${moduleNameUpperCase}_WriteStart(void)
{
    ${moduleNameLowerCase}_Status.state = ${moduleGroupNameUpperCase}_EVENT_SEND_WR_ADDR();
}

static void ${moduleNameUpperCase}_Close(void)
{
    ${moduleNameLowerCase}_Status.busy = false;
    ${moduleNameLowerCase}_Status.address = 0xFF;
    ${moduleNameLowerCase}_Status.writePtr = NULL;
    ${moduleNameLowerCase}_Status.readPtr = NULL;
    ${moduleNameLowerCase}_Status.state = ${moduleGroupNameUpperCase}_STATE_IDLE;
    ${moduleNameUpperCase}_ClearInterrupts();
    ${moduleNameUpperCase}.MSTATUS |= TWI_BUSSTATE_IDLE_gc;
}

static void ${moduleNameUpperCase}_EventHandler(void)
{
    ${moduleNameLowerCase}_Status.state = ${moduleNameLowerCase}_eventTable[${moduleNameLowerCase}_Status.state]();
}

static void ${moduleNameUpperCase}_ErrorEventHandler(void)
{
    if (${moduleNameUpperCase}_IsBusError())
    {
        ${moduleNameLowerCase}_Status.state = ${moduleGroupNameUpperCase}_STATE_ERROR;
        ${moduleNameLowerCase}_Status.errorState = ${moduleGroupNameUpperCase}_ERROR_BUS_COLLISION;
        ${moduleNameUpperCase}.MSTATUS |= TWI_BUSERR_bm;
    }
    else if (${moduleNameUpperCase}_IsAddr() && ${moduleNameUpperCase}_IsNack())
    {
        ${moduleNameLowerCase}_Status.state = ${moduleGroupNameUpperCase}_STATE_NACK;
        ${moduleNameLowerCase}_Status.errorState = ${moduleGroupNameUpperCase}_ERROR_ADDR_NACK;
        ${moduleNameUpperCase}.MSTATUS |= TWI_RXACK_bm;
    }
    else if (${moduleNameUpperCase}_IsData() && ${moduleNameUpperCase}_IsNack())
    {
        ${moduleNameLowerCase}_Status.state = ${moduleGroupNameUpperCase}_STATE_NACK;
        ${moduleNameLowerCase}_Status.errorState = ${moduleGroupNameUpperCase}_ERROR_DATA_NACK;
        ${moduleNameUpperCase}.MSTATUS |= TWI_RXACK_bm;
    }
    else if(${moduleNameUpperCase}_IsArbitrationlostOverride())
    {
        ${moduleNameLowerCase}_Status.state = ${moduleGroupNameUpperCase}_STATE_ERROR;
        ${moduleNameLowerCase}_Status.errorState = ${moduleGroupNameUpperCase}_ERROR_BUS_COLLISION;
        ${moduleNameUpperCase}.MSTATUS |= TWI_ARBLOST_bm;
    }
    ${moduleNameLowerCase}_Status.state = ${moduleNameLowerCase}_eventTable[${moduleNameLowerCase}_Status.state]();
    if(${moduleNameLowerCase}_Status.errorState != ${moduleGroupNameUpperCase}_ERROR_NONE)
    {
        ${moduleNameUpperCase}_Callback();
    }
    
}

static void ${moduleNameUpperCase}_DefaultCallback(void)
{
    // Default Callback for Error Indication
}

/* ${moduleGroupNameUpperCase} Event interfaces */
static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_IDLE(void)
{
    ${moduleNameLowerCase}_Status.busy = false;
    ${moduleNameUpperCase}.MSTATUS |= TWI_BUSSTATE_IDLE_gc;
    return ${moduleGroupNameUpperCase}_STATE_RESET;
}

static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_SEND_RD_ADDR(void)
{
    ${moduleNameUpperCase}_SendTxAddr((uint8_t) (${moduleNameLowerCase}_Status.address << 1 | 1));
    return ${moduleGroupNameUpperCase}_STATE_RX;
}

static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_SEND_WR_ADDR(void)
{
    ${moduleNameUpperCase}_SendTxAddr((uint8_t) (${moduleNameLowerCase}_Status.address << 1));
    return ${moduleGroupNameUpperCase}_STATE_TX;
}

static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_TX(void)
{
    ${moduleGroupNameLowerCase}_event_states_t retEventState = ${moduleGroupNameUpperCase}_STATE_TX;

        if (${moduleNameLowerCase}_Status.writeLength)
        {
            ${moduleNameLowerCase}_Status.writeLength--;
            ${moduleNameUpperCase}_SendTxData(*${moduleNameLowerCase}_Status.writePtr++);
            retEventState = ${moduleGroupNameUpperCase}_STATE_TX;
        }
        else
        {
            if (${moduleNameLowerCase}_Status.switchToRead)
            {
                ${moduleNameLowerCase}_Status.switchToRead = false;
                retEventState = ${moduleGroupNameUpperCase}_STATE_SEND_RD_ADDR;
            }
            else
            {
                retEventState = ${moduleGroupNameUpperCase}_EVENT_STOP();
            }
        }

    return retEventState;
}

static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_RX(void)
{
    ${moduleGroupNameLowerCase}_event_states_t retEventState = ${moduleGroupNameUpperCase}_STATE_RX;
  
    if (${moduleNameLowerCase}_Status.readLength == 1)
    {
        // Next byte will be last to be received, setup NACK
        ${moduleNameUpperCase}_HostSendNack();
    }
    else
    {
        // More bytes to receive, setup ACK
        ${moduleNameUpperCase}_HostSendAck();
    }

    if (--${moduleNameLowerCase}_Status.readLength)
    {
        *${moduleNameLowerCase}_Status.readPtr++ = ${moduleNameUpperCase}_GetRxData();
        //Execute Acknowledge Action followed by a byte read operation
        ${moduleNameUpperCase}.MCTRLB |= TWI_MCMD_RECVTRANS_gc;
        retEventState = ${moduleGroupNameUpperCase}_STATE_RX;
    }
    else
    {
        *${moduleNameLowerCase}_Status.readPtr++ = ${moduleNameUpperCase}_GetRxData();
        ${moduleNameUpperCase}_HostSendNack();
        retEventState = ${moduleGroupNameUpperCase}_EVENT_STOP();
    }
 
    return retEventState;
}

static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_NACK(void)
{
    ${moduleGroupNameLowerCase}_event_states_t retEventState = ${moduleGroupNameUpperCase}_STATE_NACK;
    retEventState = ${moduleGroupNameUpperCase}_EVENT_STOP();
    return retEventState;
}

static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_ERROR(void)
{
    // Clear bus collision status flag
    ${moduleGroupNameLowerCase}_event_states_t retEventState = ${moduleGroupNameUpperCase}_STATE_ERROR;
    ${moduleNameUpperCase}_ClearInterrupts();
    retEventState = ${moduleGroupNameUpperCase}_EVENT_RESET();
    return retEventState;
}

static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_STOP(void)
{
    ${moduleNameUpperCase}_SendStop();
    ${moduleNameUpperCase}_Close();
    return ${moduleGroupNameUpperCase}_STATE_IDLE;
}

static ${moduleGroupNameLowerCase}_event_states_t ${moduleGroupNameUpperCase}_EVENT_RESET(void)
{
    ${moduleNameUpperCase}_ResetBus();
    ${moduleNameLowerCase}_Status.busy = false;
    return ${moduleGroupNameUpperCase}_STATE_IDLE;
}

ISR(TWI${instanceNumber}_TWIM_vect)
{
    if ((${moduleNameUpperCase}.MSTATUS & TWI_RXACK_bm) || (${moduleNameUpperCase}.MSTATUS & TWI_BUSERR_bm) || (${moduleNameUpperCase}.MSTATUS & TWI_ARBLOST_bm))
    {
        ${moduleNameUpperCase}_ErrorEventHandler();
    }

    if ((${moduleNameUpperCase}.MSTATUS & TWI_RIF_bm) || (${moduleNameUpperCase}.MSTATUS & TWI_WIF_bm))
    {
        if ((${moduleNameUpperCase}.MSTATUS & TWI_RXACK_bm) || (${moduleNameUpperCase}.MSTATUS & TWI_BUSERR_bm) || (${moduleNameUpperCase}.MSTATUS & TWI_ARBLOST_bm))
        {
            ${moduleNameUpperCase}_ErrorEventHandler();
        }
        else
        {
            ${moduleNameUpperCase}_EventHandler();
        }
    }
}

/**
 Section: Register Level Interfaces
 */

static uint8_t ${moduleNameUpperCase}_GetRxData(void)
{
    return ${moduleNameUpperCase}.MDATA;
}

static void ${moduleNameUpperCase}_SendTxData(uint8_t data)
{
    ${moduleNameUpperCase}.MDATA = data;
}

static void ${moduleNameUpperCase}_SendTxAddr(uint8_t data)
{
    ${moduleNameUpperCase}.MADDR = data;
}

static inline void ${moduleNameUpperCase}_ResetBus(void)
{
    //Set Clear Buffer Flag
    ${moduleNameUpperCase}.MCTRLA &= ~(1 << TWI_ENABLE_bp);
    ${moduleNameUpperCase}.MCTRLA |= 1 << TWI_ENABLE_bp;
}

static void ${moduleNameUpperCase}_ClearInterruptFlag(void)
{
    if(${moduleNameUpperCase}.MSTATUS & TWI_RIF_bm)
    {
        ${moduleNameUpperCase}.MSTATUS|= TWI_RIF_bm;
    }
    else if(${moduleNameUpperCase}.MSTATUS & TWI_WIF_bm)
    {
        ${moduleNameUpperCase}.MSTATUS|= TWI_WIF_bm;
    }
}

static inline void ${moduleNameUpperCase}_EnableRestart(void)
{
    //Enable ${moduleNameUpperCase} Restart
    ${moduleNameUpperCase}.MCTRLB |= TWI_MCMD_REPSTART_gc;
}

static inline void ${moduleNameUpperCase}_DisableRestart(void)
{
    //Disable ${moduleNameUpperCase} Restart
    ${moduleNameUpperCase}.MCTRLB &= ~TWI_MCMD_REPSTART_gc;
}

static inline void ${moduleNameUpperCase}_SendStop(void)
{
    //Clear Start Bit
    ${moduleNameUpperCase}.MCTRLB |= TWI_MCMD_STOP_gc;
}

static bool ${moduleNameUpperCase}_IsNack(void)
{
    return ${moduleNameUpperCase}.MSTATUS & TWI_RXACK_bm;
}

static bool ${moduleNameUpperCase}_IsBusError(void)
{
    return ${moduleNameUpperCase}.MSTATUS & TWI_BUSERR_bm;
}

static bool ${moduleNameUpperCase}_IsData(void)
{
    return ${moduleNameUpperCase}.MDATA;
}

static bool ${moduleNameUpperCase}_IsAddr(void)
{
    return ${moduleNameUpperCase}.MADDR;
}

static bool ${moduleNameUpperCase}_IsArbitrationlostOverride(void)
{
    return ${moduleNameUpperCase}.MSTATUS & TWI_ARBLOST_bm;
}

static inline void ${moduleNameUpperCase}_ClearErrorFlags(void)
{
   ${moduleNameUpperCase}.MSTATUS |= TWI_RXACK_bm;
   ${moduleNameUpperCase}.MSTATUS |= TWI_BUSERR_bm;
   ${moduleNameUpperCase}.MSTATUS |= TWI_ARBLOST_bm;
}

static inline void ${moduleNameUpperCase}_HostSendAck(void)
{
    ${moduleNameUpperCase}.MCTRLB &= ~(1 << TWI_ACKACT_bp);
}

static inline void ${moduleNameUpperCase}_HostSendNack(void)
{
    ${moduleNameUpperCase}.MCTRLB |= TWI_ACKACT_NACK_gc;
}

static inline void ${moduleNameUpperCase}_EnableInterrupts(void)
{
    ${moduleNameUpperCase}.MCTRLA |= (TWI_RIEN_bm | TWI_WIEN_bm);
}

static inline void ${moduleNameUpperCase}_DisableInterrupts(void)
{
    ${moduleNameUpperCase}.MCTRLA &= ~(TWI_RIEN_bm | TWI_WIEN_bm);
}

static inline void ${moduleNameUpperCase}_ClearInterrupts(void)
{
   ${moduleNameUpperCase}.MSTATUS |= (TWI_RIF_bm | TWI_WIF_bm);
}