/**
 * ${moduleNameUpperCase} Generated Driver API Header File
 *
 * @file {moduleGroupNameLowerCase}_host_interface.h
 *
 * @defgroup ${moduleNameLowerCase}_host_interface ${moduleNameUpperCase}_HOST_INTERFACE
 *
 * @brief This header file provides APIs for the ${moduleNameUpperCase} driver.
 *
 * @version ${moduleNameUpperCase} Driver Version 2.0.2
*/

${disclaimer}

#ifndef ${moduleGroupNameUpperCase}_HOST_INTERFACE_H
#define ${moduleGroupNameUpperCase}_HOST_INTERFACE_H
/**
  Section: Included Files
*/
#include <stdbool.h>
#include <stdint.h>
#include "${moduleGroupNameLowerCase}_host_types.h"
    
/**
 * @ingroup ${moduleNameLowerCase}_host
 * @struct ${moduleGroupNameLowerCase}_host_interface_t 
 * @brief Structure containing the function pointers of ${moduleGroupNameUpperCase} driver.
 */
typedef struct
{   
    void (*Initialize)(void);
    void (*Deinitialize)(void);
    bool (*Write)(uint16_t address, uint8_t *data, size_t dataLength);
    bool (*Read)(uint16_t address, uint8_t *data, size_t dataLength);
    bool (*WriteRead)(uint16_t address, uint8_t *writeData, size_t writeLength, uint8_t *readData, size_t readLength);
    bool (*TransferSetup)(struct ${moduleGroupNameUpperCase}_TRANSFER_SETUP* setup, uint32_t srcClkFreq);
    ${moduleGroupNameLowerCase}_host_error_t (*ErrorGet)(void);
    bool (*IsBusy)(void);
    void (*CallbackRegister)(void (*callback)(void));
    void (*Tasks)(void);
}${moduleGroupNameLowerCase}_host_interface_t;

#endif // end of ${moduleGroupNameUpperCase}_HOST_INTERFACE_H