import { DerivedData } from "@microchip/scf-automodule-interface";
import { getModel } from "../generated_module/src/App/AppModel";
import { mockState } from "../generated_module/tests/AppModel.test";
import { mockAssignedModule } from "../generated_module/tests/processor.test";
import { getDerivedData } from "./DerivedData";

describe("DerivedData overrideDefaultValues undefined Hardware test cases -- >", () => {
    const mockModule = mockAssignedModule(mockState());
    const model = getModel(mockModule, getDerivedData);
    if (model) {
        model.getComponentValue = (): any => {
            return {
                mode: "Host",
            };
        };
    }

    const derivedData = model?.getDerivedData() as DerivedData;
    const derivedFunctions = derivedData?.getMyFunctions();
    const output = derivedFunctions?.isClientModePolling?.();

    it("Test for overrideDefaultValues result", () => {
        expect(output).toBe(false);
    });
});

describe("DerivedData overrideDefaultValues undefined Hardware test cases -- >", () => {
    const mockModule = mockAssignedModule(mockState());
    const model = getModel(mockModule, getDerivedData);
    if (model) {
        model.getComponentValue = (): any => {
            return {
                mode: "Client",
            };
        };
    }

    const derivedData = model?.getDerivedData() as DerivedData;
    const derivedFunctions = derivedData?.getMyFunctions();
    const output = derivedFunctions?.isClientModePolling?.();

    it("Test for overrideDefaultValues result", () => {
        expect(output).toBe(false);
    });
});

describe("Test case for -- >", () => {
    const mockModule = mockAssignedModule(mockState());
    const model = getModel(mockModule, getDerivedData);
    if (model) {
        model.getComponentValue = (): any => {
            return {
                mode: "Client",
            };
        };
    }
    // let output="";

    // if(model)
    // {
    //      output = getI2CModeFunctions(model);
    // }

    it("Test for overrideDefaultValues result", () => {
        // expect(output).toBe(false);
    });
});
