import { pin_row } from "@microchip/pin-standard";
import { AppModel } from "../generated_module/src/types/AutoModuleTypes";
// import { PCPHelper } from "../generated_module/src/pins/PCPHelper";
// import { pingroups_data, pins_group } from "@microchip/pin-standard/lib/pin-standard";
// import { getKeys } from "../generated_module/src/Utils";
// import { Dictionary } from "@microchip/scf-common/lib/Processor";

// let retRowJSONdata: pin_row = rowData;
// const mod = appModel.getHardware()?.getName();
// const pinPayload = appModel?.getImportValue("pin_standard") ?? {};

// provide complete dynamic data for all pin rows. It overrides static pindata.json
export const getCompletePinData = (appModel: AppModel): any => {
    // way to programatically override the json data
    return {};
};

// overrides pin data for a particular row based on model.
export function getRowData(appModel: AppModel, rowData: pin_row): pin_row {
    const TwiInstanceName = appModel.getHardware()?.getPeripheral()?.instance;
    // const targetportmuxreg = "PORTMUX.USARTROUTEA";
    // const targetportmuxsetting = "USART0";
    //const portmuxgrp: string = filterGroupName(pinPayload,targetportmuxreg,targetportmuxsetting,);
    if (rowData.name === "scl") {
        rowData = {
            ...rowData,
            module: "TWI" + TwiInstanceName,
            filter: {
                ...rowData.filter,
                module: "TWI" + TwiInstanceName,
            },
        };
    } else if (rowData.name === "sda") {
        rowData = {
            ...rowData,
            module: "TWI" + TwiInstanceName,
            filter: {
                ...rowData.filter,
                module: "TWI" + TwiInstanceName,
            },
        };
    }
    return rowData;
}
